Index: /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComPic.h
===================================================================
--- /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComPic.h	(revision 1319)
+++ /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComPic.h	(revision 1320)
@@ -407,4 +407,5 @@
 #endif
 public: 
+  TComPicLists() { m_printPicOutput = false; };
   ~TComPicLists();
 
Index: /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComPrediction.cpp	(revision 1319)
+++ /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComPrediction.cpp	(revision 1320)
@@ -566,9 +566,9 @@
       Int layerIdL0 = pcCU->getSlice()->getRefPic(REF_PIC_LIST_0, pcCU->getCUMvField(REF_PIC_LIST_0)->getRefIdx(PartAddr))->getLayerId();
       Int layerIdL1 = pcCU->getSlice()->getRefPic(REF_PIC_LIST_1, pcCU->getCUMvField(REF_PIC_LIST_1)->getRefIdx(PartAddr))->getLayerId();
-#endif
-#if NH_MV
+#if NH_3D_ARP
+      if(!pcCU->getARPW(PartAddr) && RefPOCL0 == RefPOCL1 && layerIdL0 == layerIdL1 && pcCU->getCUMvField(REF_PIC_LIST_0)->getMv(PartAddr) == pcCU->getCUMvField(REF_PIC_LIST_1)->getMv(PartAddr))
+#else
       if(RefPOCL0 == RefPOCL1 && layerIdL0 == layerIdL1 && pcCU->getCUMvField(REF_PIC_LIST_0)->getMv(PartAddr) == pcCU->getCUMvField(REF_PIC_LIST_1)->getMv(PartAddr))
-#elif NH_3D_ARP
-      if(!pcCU->getARPW(PartAddr) && RefPOCL0 == RefPOCL1 && layerIdL0 == layerIdL1 && pcCU->getCUMvField(REF_PIC_LIST_0)->getMv(PartAddr) == pcCU->getCUMvField(REF_PIC_LIST_1)->getMv(PartAddr))
+#endif
 #else
       if(RefPOCL0 == RefPOCL1 && pcCU->getCUMvField(REF_PIC_LIST_0)->getMv(PartAddr) == pcCU->getCUMvField(REF_PIC_LIST_1)->getMv(PartAddr))
Index: /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComRom.cpp	(revision 1319)
+++ /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComRom.cpp	(revision 1320)
@@ -564,4 +564,5 @@
 Bool g_traceMotionInfoBeforUniPred = false; 
 Bool g_traceMergeCandListConst = false; 
+Bool g_traceBitsRead          = false; 
 Bool g_traceSubPBMotion       = false; 
 #endif
@@ -756,4 +757,34 @@
     fflush ( g_hTrace );    
   }
+}
+Void printStr( std::string str )
+{
+  std::cout << str << std::endl; 
+}
+Void printStrIndent( Bool b, std::string strStr )
+{
+  if ( b )
+  {  
+    std::cout << std::string(g_indent, ' ');
+    printStr( strStr );
+  }
+}
+Void prinStrIncIndent( Bool b,  std::string strStr )
+{
+  if ( b )
+  {
+    printStrIndent( true,  strStr );
+    if (g_indent < 50)
+    {
+      g_indent++;
+    }
+  }  
+}
+Void decIndent( Bool b )
+{
+  if (b && g_indent > 0)
+  {
+    g_indent--;  
+  }  
 }
 #endif
Index: /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComRom.h
===================================================================
--- /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComRom.h	(revision 1319)
+++ /branches/HTM-15.0-dev0/source/Lib/TLibCommon/TComRom.h	(revision 1320)
@@ -95,5 +95,4 @@
 // Depth coding modes
 // ====================================================================================================================
-
 extern const WedgeResolution                                 g_dmmWedgeResolution [6];
 extern const UChar                                           g_dmm1TabIdxBits     [6];
@@ -197,4 +196,5 @@
  extern Bool   g_traceMergeCandListConst; 
  extern Bool   g_traceSubPBMotion; 
+ extern Bool   g_traceBitsRead;
 #define DTRACE_CU(x,y)             writeToTraceFile( x,y, g_traceCU );
 #define DTRACE_PU(x,y)             writeToTraceFile( x,y, g_tracePU );
@@ -203,9 +203,7 @@
 #define DTRACE_PU_S(x)             writeToTraceFile( x,   g_tracePU );
 #define DTRACE_TU_S(x)             writeToTraceFile( x,   g_traceTU );
-
 #define D_DEC_INDENT( b )            decIndent        ( b );
 #define D_PRINT_INC_INDENT( b, str ) prinStrIncIndent( b, str );
 #define D_PRINT_INDENT( b, str )     printStrIndent   ( b, str);
-
  Void           tracePSHeader   ( const Char* psName, Int layerId ); 
  Void           writeToTraceFile( const Char* symbolName, Int val, Bool doIt );
@@ -213,10 +211,8 @@
  UInt64         incSymbolCounter();          
  Void           stopAtPos       ( Int poc, Int layerId, Int cuPelX, Int cuPelY, Int cuWidth, Int cuHeight );           
-
  Void           printStr         ( std::string str );
  Void           printStrIndent   ( Bool b, std::string str );
  Void           prinStrIncIndent ( Bool b, std::string str );
  Void           decIndent        ( Bool b );
-
  template <typename T>
  std::string n2s ( T Number )
@@ -226,5 +222,4 @@
    return ss.str();
  };
-
 #endif
 #else
@@ -243,5 +238,4 @@
 #define DTRACE_PU_S(x) ;            
 #define DTRACE_TU_S(x) ;            
-
 #define D_DEC_INDENT( b ) ;
 #define D_PRINT_INC_INDENT( b, str );